*******************************************************************************************************************
******** 6.9.    "-++"
********  -     "-++"    ,   Internet, 
********         ,    PHP-,  
********    ,   IP- ,     ,    -
********  ,    
*******************************************************************************************************************
FUNCTION F6_9()

LOCAL GetList := {}, aPres, oBrowse, oToolBar, aColors, bColor, GetOptions, oEventsKO, bItems, n:=0

Local oHttp, oResponse, cColor

   IF InternetGetConnectedState( @n, 0 ) == 0
      LB_Warning('   Internet,     !', '(C)  "-++"' )
      RETURN NIL
   ENDIF

*       'test_strings.txt'  
*  DC_SpawnURL( 'http://j90540lw.beget.tech/test_strings.txt', .T., .T. )

   *     : 'test_strings.txt'  : 'http://j90540lw.beget.tech'
   *        (  2.3.2.2)     ,    

   *****   "test_strings.txt",   HTTP (GetWeb.prg, Boris Borzic)
   oHttp := xbHTTPClient():new()
   oHttp:Transport := VIA_WININET
   oResponse := oHttp:Execute( 'http://j90540lw.beget.tech/test_strings.txt' )
   if oResponse == NIL
      MsgBox("Error:" + str(oHttp:ErrorCode) + chr(10) + oHttp:ErrorMessage + chr(10) + oHttp:ErrorSource)
      Return .f.
   endif
   mABC = oResponse:Content
   StrFile(mABC,'test_strings.txt')
   ****************************************************************************************

*    : "test_strings.txt"          2.3.2.2.
*  mABC = FileStr('test_strings.txt')    //        
*  @ 1,1 DCMULTILINE mABC FONT '12.Courier New' SIZE 180.0,27.0 EDITPROTECT {||.T.}
*        DCREAD GUI ;
*        TITLE '6.9.    "-++"' ;
*        FIT

CrLf = CHR(13)+CHR(10)     //   ()

****     : 06.12.16,20:41:32,93.91.80.6,US,United States,,,,,,37.75,-97.82,0
****    : 06.12.16,20:41:32,93.91.80.6,US,United States,Unknown,Unknown,Unknown,Unknown,Unknown,37.75,-97.82,0

mABC = FileStr('test_strings.txt')    //     
FOR j=1 TO 12
    mABC = STRTRAN(mABC,',,',',Unknown,')
NEXT
StrFile(mABC,'test_strings.txt')      //     

*****   : "test_strings.txt"  DBF-   , 
*****         HELP
*****  ..  (  )

***** 06.12.16,10:30:37,37.146.34.226,RU,Russia,KDA,Krasnodarskiy Kray,Krasnodar,350000,Europe/Moscow,45.03,38.98,0

 *******       Visitors.dbf

 PRIVATE aLenF[13]
 AFILL(aLenF, -99999)

 nHandle := DC_txtOpen( 'test_strings.txt' )
 DO WHILE !DC_TxtEOF( nHandle )              //    
    mLine = DC_TxtLine( nHandle )            //     
    FOR j=1 TO NUMTOKEN(mLine,",")           //    - 
        aLenF[j] = MAX(aLenF[j], LEN(ALLTRIM(TOKEN(mLine, ",", j))))
    NEXT
    DC_TxtSkip( nHandle, 1 )
 ENDDO
 DC_TxtClose( nHandle )

*DC_DebugQout( aLenF )

aStructure := { { "Date"      , "C", aLenF[ 1], 0 }, ;   //  1
                { "Time"      , "C", aLenF[ 2], 0 }, ;   //  2
                { "IP_address", "C", aLenF[ 3], 0 }, ;   //  3
                { "Domain"    , "C", aLenF[ 4], 0 }, ;   //  4
                { "Country"   , "C", aLenF[ 5], 0 }, ;   //  5
                { "Okrug"     , "C", aLenF[ 6], 0 }, ;   //  6
                { "Region"    , "C", aLenF[ 7], 0 }, ;   //  7
                { "City"      , "C", aLenF[ 8], 0 }, ;   //  8
                { "Postcode"  , "C", aLenF[ 9], 0 }, ;   //  9
                { "Timezone"  , "C", aLenF[10], 0 }, ;   // 10
                { "Latitude"  , "N", aLenF[11], 2 }, ;   // 11
                { "Longitude" , "N", aLenF[12], 2 }, ;   // 12
                { "UnKnown"   , "N", aLenF[13], 0 }  }   // 13

DbCreate( 'Visitors', aStructure )

CLOSE ALL
USE Visitors EXCLUSIVE NEW

 nHandle := DC_txtOpen( 'test_strings.txt' )

 DO WHILE !DC_TxtEOF( nHandle )              //    

    mLine = DC_TxtLine( nHandle )            //     

    **     

    aR := {}
    FOR w=1 TO NUMTOKEN(mLine,",")           //    - 
        AADD(aR, TOKEN(mLine, ",", w))       //   
    NEXT

    SELECT Visitors
    APPEND BLANK
    FOR j=1 TO LEN(aR)
        IF j <= 10
           FIELDPUT(j, aR[j])
        ELSE
           FIELDPUT(j, VAL(aR[j]))
        ENDIF
    NEXT

    IF SUBSTR(Time,2,1)=':'
       REPLACE Time WITH ' '+Time
    ENDIF

    DC_TxtSkip( nHandle, 1 )

 ENDDO
 DC_TxtClose( nHandle )

 *******   *******

 PUBLIC mDate1, mDate2
 DBGOTOP()   ;mDate1 = Date
 DBGOBOTTOM();mDate2 = Date
 SET FILTER TO CTOD(mDate1) <= CTOD(Date) .AND. CTOD(Date) <= CTOD(mDate2)

 sLenF = 33
 FOR j=1 TO 12
     sLenF = sLenF + aLenF[j]
 NEXT
*MsgBox(STR(sLenF))

/* ----- Create ToolBar ----- */

@28.3,0           DCGROUP oGroup1 CAPTION ''                                 SIZE sLenF+0, 4.0              
@ 0.5, 2          DCGROUP oGroup2 CAPTION ''                                 SIZE LEN('')            +5, 3.0                                                 PARENT oGroup1
@ 1  , 1          DCPUSHBUTTON    CAPTION ''                           SIZE LEN('')            +2, 1.5 ACTION {||Help69(), DC_GetRefresh(GetList)}     PARENT oGroup2
                                                                                                           
d = 10                                                                                                     
@ 0.5, 15         DCGROUP oGroup3 CAPTION ':'                      SIZE 62, 3.0                                                                          PARENT oGroup1
@ 1  ,  1         DCPUSHBUTTON    CAPTION '   '                SIZE LEN('   ') +2, 1.5 ACTION {||Sorting69(1), DC_GetRefresh(GetList)} PARENT oGroup3
@ 1  ,DCGUI_COL+d DCPUSHBUTTON    CAPTION ' IP-'                     SIZE LEN(' IP-')      +2, 1.5 ACTION {||Sorting69(2), DC_GetRefresh(GetList)} PARENT oGroup3
@ 1  ,DCGUI_COL+d DCPUSHBUTTON    CAPTION ' '                        SIZE LEN(' ')         +2, 1.5 ACTION {||Sorting69(3), DC_GetRefresh(GetList)} PARENT oGroup3
@ 1  ,DCGUI_COL+d DCPUSHBUTTON    CAPTION ' '                        SIZE LEN(' ')         +2, 1.5 ACTION {||Sorting69(4), DC_GetRefresh(GetList)} PARENT oGroup3
                                                                                                           
@ 0.5, 79         DCGROUP oGroup4 CAPTION ' ( FTP-):'    SIZE 32, 3.0                                                                          PARENT oGroup1
@ 1  ,  1         DCPUSHBUTTON    CAPTION ' '                     SIZE LEN(' ')      +2, 1.5 ACTION {||Visual69(1),  DC_GetRefresh(GetList)} PARENT oGroup4
@ 1  ,DCGUI_COL+d DCPUSHBUTTON    CAPTION ' '                     SIZE LEN(' ')      +2, 1.5 ACTION {||Visual69(2),  DC_GetRefresh(GetList)} PARENT oGroup4

@ 0.5,113         DCGROUP oGroup5 CAPTION ' ( HTTP-):' SIZE 47, 3.0                                                                          PARENT oGroup1
@ 1  ,  1         DCPUSHBUTTON    CAPTION '  '               SIZE LEN('  ')+2, 1.5 ACTION {||Visual69(3),  DC_GetRefresh(GetList)} PARENT oGroup5
@ 1  ,DCGUI_COL+d DCPUSHBUTTON    CAPTION '  '                SIZE LEN('  ') +2, 1.5 ACTION {||Visual69(4),  DC_GetRefresh(GetList)} PARENT oGroup5

******   ***************

SELECT Visitors
DBGOTOP()

DCSETPARENT TO

@ 5, 0 DCBROWSE Visitors ALIAS 'Visitors' SIZE sLenF,23 ;
       PRESENTATION DC_BrowPres() ;       //   
       NOSOFTTRACK ;
       HEADLINES 2 ;                      // -    (  - ";")
       SCOPE ;
       ITEMMARKED bItems

DCSETPARENT Visitors

***   

DCBROWSECOL FIELD Visitors->Date       HEADER ";.."   PARENT Visitors WIDTH aLenF[ 1]+1 FONT "9.Courier"                            
DCBROWSECOL FIELD Visitors->Time       HEADER ";::"  PARENT Visitors WIDTH aLenF[ 2]+1 FONT "9.Courier"                            
DCBROWSECOL FIELD Visitors->IP_address HEADER "IP-"        PARENT Visitors WIDTH aLenF[ 3]+1 FONT "9.Courier" COLOR {||{nil,aColor[100]}}
DCBROWSECOL FIELD Visitors->Domain     HEADER ""           PARENT Visitors WIDTH aLenF[ 4]+4 FONT "9.Courier"                            
DCBROWSECOL FIELD Visitors->Country    HEADER ""          PARENT Visitors WIDTH aLenF[ 5]+1 FONT "9.Courier"                            
DCBROWSECOL FIELD Visitors->Okrug      HEADER ""           PARENT Visitors WIDTH aLenF[ 6]+1 FONT "9.Courier"                            
DCBROWSECOL FIELD Visitors->Region     HEADER ""          PARENT Visitors WIDTH aLenF[ 7]+1 FONT "9.Courier"                            
DCBROWSECOL FIELD Visitors->City       HEADER ""           PARENT Visitors WIDTH aLenF[ 8]+1 FONT "9.Courier"                            
DCBROWSECOL FIELD Visitors->Postcode   HEADER ";" PARENT Visitors WIDTH aLenF[ 9]+1 FONT "9.Courier"
DCBROWSECOL FIELD Visitors->Timezone   HEADER ";"  PARENT Visitors WIDTH aLenF[10]+1 FONT "9.Courier"
DCBROWSECOL FIELD Visitors->Latitude   HEADER ""          PARENT Visitors WIDTH aLenF[11]+1 FONT "9.Courier"
DCBROWSECOL FIELD Visitors->Longitude  HEADER ""         PARENT Visitors WIDTH aLenF[12]+1 FONT "9.Courier"
*DCBROWSECOL FIELD Visitors->UnKnown   HEADER "UnKnown"         PARENT Visitors WIDTH aLenF[13]+1 FONT "9.Courier"

DCGETOPTIONS SAYFONT '10.Helv Bold' TABSTOP AUTORESIZE

DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   MODAL ;
   TITLE '6.9.    "-++"' ;
   EVAL {|o|SetAppFocus(Visitors:GetColumn(1))}

   **************************************************************
   ***** ,     
   *****        
   **************************************************************
   CLOSE ALL
   DIRCHANGE(Disk_dir)                          //       
   USE PathGrAp EXCLUSIVE NEW
   USE Appls    EXCLUSIVE NEW
   USE Users    EXCLUSIVE NEW
   **         : _CloseFunct.txt,   
   IF FILE('_CloseFunct.txt')
      ERASE('_CloseFunct.txt')
   ENDIF
   **************************************************************

RETURN NIL

********    6.9
FUNCTION Help69()
LOCAL GetList[0], cText

TEXT INTO cText WRAP "\n" TRIMMED
   : 6.9.    "-++".

 -     "-++"    ,   Internet,    
    : 'http://j90540lw.beget.tech',    index.php   PHP-:

<?php 
  $file = 'test_strings.txt';                                 //  
  define("divider", ",");                                     // 
  $logdate = date("d.m.y,G:i:s");                             // , 
  $ip = getenv('HTTP_X_REAL_IP');                             // ip-
  if ( $ip == '' ) $ip = 'unknown';                           // ,   ip-
  $var=file_get_contents('http://freegeoip.net/csv/' . $ip);  //  ,    .
  $log = $logdate . divider . $var ;                          //  
  file_put_contents($file, $log, FILE_APPEND | LOCK_EX);      //    
  echo '<meta http-equiv="refresh" content="0;URL=http://lc.kubagro.ru">';    //    
?>

      ,   IP- ,     ,     
 ,    .         : 'test_strings.txt',
  ,     ()    : http://lc.kubagro.ru. 

 6.9.   FTP   'test_strings.txt'  : http://j90540lw.beget.tech     DBF-: 
'Visitors.DBF',               . 

    FTP-,          
   ,    ,      .

    FTP- (    ,     ),  
     , ,    HTTP-.   
       .      . PHP- -
  : 'test_strings.txt'   : ../Aidos-X/Sheet_changes.doc  11.12.2016.
ENDTEXT

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 0 ;
     CAPTION cText FORMATTED ;
     FONT '10.Lucida Console' ;
     COLOR GRA_CLR_BLACK, GRA_CLR_WHITE

DCREAD GUI FIT TITLE '  : 6.9.    "-++"'

ReTURN nil
*****************************************************************************************

FUNCTION Sorting69(Par)

DO CASE
   CASE Par = 1             
        INDEX ON Date+Time+IP_address TO Sort69        //    
   CASE Par = 2                                                  
        INDEX ON IP_address+Date+Time TO Sort69        //  IP-     
   CASE Par = 3                                                  
        INDEX ON Country+Date+Time    TO Sort69        //          
   CASE Par = 4                                                  
        INDEX ON City+Date+Time       TO Sort69        //          
ENDCASE

DBGOTOP()

ReTURN nil

*****************************************************************************************

FUNCTION Visual69(Par)

*******  'Visitors.DBF'   : 'map_strings.txt'  ,
*******    FTP        http://j90540lw.beget.tech/map2.php

IF Par = 2
   ***    ********************************************
   DBGOTOP()   ;mDate1 = Date                                          
   DBGOBOTTOM();mDate2 = Date                                          
   @0,0 DCGROUP oGroup1 CAPTION '  :' SIZE 37.0, 3.5 
   @1,2 DCSAY " :" GET mDate1 PARENT oGroup1              
   @2,2 DCSAY "  :" GET mDate2 PARENT oGroup1              
   DCREAD GUI;                                                         
         TO lExit ;                                                    
         FIT;                                                          
         ADDBUTTONS;                                                   
         MODAL;                                                              
         TITLE '(c)  -X++'                                           
         IF lExit                                                           
            ** Button Ok                                                    
         ELSE                                                               
            QUIT                                                            
         ENDIF                                                              
   ********************************************************************     
ENDIF

**  'Visitors.DBF'   : 'map_strings.txt'         FTP

IF Par <= 2
        SET FILTER TO CTOD(mDate1) <= CTOD(Date) .AND. CTOD(Date) <= CTOD(mDate2)

        mABC = ''
        DBGOTOP()
        DO WHILE .NOT. EOF()
           FOR j=1 TO 13
               mVal = FIELDGET(j)
               DO CASE
                  CASE VALTYPE(mVal) = 'C'
                       mABC = mABC + mVal + IF(j<13,',','')
                  CASE VALTYPE(mVal) = 'N'
                       mABC = mABC + STR(mVal,8,IF(j<13,2,0)) + IF(j<13,',','')
               ENDCASE
           NEXT
           mABC = mABC + CrLf
           DBSKIP(1)
        ENDDO
        StrFile(mABC, 'map_strings.txt')       //          

        *******   'map_strings.txt'  FTP  : http://j90540lw.beget.tech

        cGDServer:="ftp://j90540lw.beget.tech"                                                                                      
                                                                                                                                    
        oFtp := XbFTPClient():new()                                                                                                 
                                                                                                                                    
        IF oFtp:Connect(cGDServer)                          //                                                            
           IF oFtp:Login(Ftp_User, Ftp_Passw)               //                                                           
                                                                                                                                    
              ****   : ftp://j90540lw.beget.tech/aidos/public_html/                                              
                                                                                                                                    
              if ! oFtp:SetCurrentDirectory("aidos/public_html/")                                                                   
                 LB_Warning('    : "aidos/public_html/"', '(C)  "-++"' )              
                 RETURN NIL                                                                                                         
              endif                                                                                                                 
                                                                                                                                    
              oFtp:PassiveMode:=.T.                         //                                                        
                                                                                                                                    
              oScrn   := DC_WaitOn( '  FTP- : "map_strings.txt"      "-++"' )
              IF oFtp:PutFile("map_strings.txt", "map_strings.txt")                                                                                   
                 DC_Impl(oScrn)                                                                                                     
        *        LB_Warning('  : "map_strings.txt"  FTP-  ', '(C)  "-++"' )             
              ENDIF                                                                                                                 
                                                                                                          
           ELSE                                                                                                                     
              LB_Warning('   FTP-', '(C)  "-++"')                                               
              RETURN NIL                                                                                                            
           ENDIF                                                                                                                    
        ELSE                                                                                                                        
           LB_Warning('   FTP-', '(C)  "-++"')                                                   
           RETURN NIL                                                                                                               
        ENDIF                                                                                                                       
ENDIF

*******     http://j90540lw.beget.tech/map#.php

DO CASE
   CASE Par = 1   //     
        DC_SpawnURL( 'http://j90540lw.beget.tech/map1.php' )
   CASE Par = 2   //     
        DC_SpawnURL( 'http://j90540lw.beget.tech/map2.php' )
   CASE Par = 3   //   FTP,    HTTP,   
        DC_SpawnURL( 'http://j90540lw.beget.tech/map3.php' )
   CASE Par = 4   //   FTP,    HTTP,   
        DC_SpawnURL( 'http://j90540lw.beget.tech/map4.php' )
ENDCASE

DBGOTOP()

ReTURN nil
******************************************************************************************
******************************************************************************************
******************************************************************************************
DLLFUNCTION InternetGetConnectedState( @nFlags, nReserved ) USING STDCALL FROM WinInet.Dll
******************************************************************************************
FUNCTION Xb2NetKey()
PUBLIC Ftp_User  := '***'
PUBLIC Ftp_Passw := '***'
Return(put your Xb2.NET license key here)    // <-- put your Xb2.NET license key here
